/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.glass.model;

import com.google.api.client.json.GenericJson;

/**
 * A notification delivered by the API.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Glass Mirror API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Notification extends GenericJson {

  /**
   * The user token provided by the service when it subscribed for notifications.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String userToken;

  /**
   * The collection that generated the notification.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String collection;

  /**
   * If the operation is MENU_ACTION, this contains the MenuItems that were selected to trigger the
   * notification.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<MenuItem> menuActions;

  static {
    // hack to force ProGuard to consider MenuItem used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(MenuItem.class);
  }

  /**
   * The secret verify token provided by the service when it subscribed for notifications.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String verifyToken;

  /**
   * The type of operation that generated the notification.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String operation;

  /**
   * The ID of the item that generated the notification.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String itemId;

  /**
   * The user token provided by the service when it subscribed for notifications.
   * The value returned may be {@code null}.
   */
  public String getUserToken() {
    return userToken;
  }

  /**
   * The user token provided by the service when it subscribed for notifications.
   * The value set may be {@code null}.
   */
  public Notification setUserToken(String userToken) {
    this.userToken = userToken;
    return this;
  }

  /**
   * The collection that generated the notification.
   * The value returned may be {@code null}.
   */
  public String getCollection() {
    return collection;
  }

  /**
   * The collection that generated the notification.
   * The value set may be {@code null}.
   */
  public Notification setCollection(String collection) {
    this.collection = collection;
    return this;
  }

  /**
   * If the operation is MENU_ACTION, this contains the MenuItems that were selected to trigger the
   * notification.
   * The value returned may be {@code null}.
   */
  public java.util.List<MenuItem> getMenuActions() {
    return menuActions;
  }

  /**
   * If the operation is MENU_ACTION, this contains the MenuItems that were selected to trigger the
   * notification.
   * The value set may be {@code null}.
   */
  public Notification setMenuActions(java.util.List<MenuItem> menuActions) {
    this.menuActions = menuActions;
    return this;
  }

  /**
   * The secret verify token provided by the service when it subscribed for notifications.
   * The value returned may be {@code null}.
   */
  public String getVerifyToken() {
    return verifyToken;
  }

  /**
   * The secret verify token provided by the service when it subscribed for notifications.
   * The value set may be {@code null}.
   */
  public Notification setVerifyToken(String verifyToken) {
    this.verifyToken = verifyToken;
    return this;
  }

  /**
   * The type of operation that generated the notification.
   * The value returned may be {@code null}.
   */
  public String getOperation() {
    return operation;
  }

  /**
   * The type of operation that generated the notification.
   * The value set may be {@code null}.
   */
  public Notification setOperation(String operation) {
    this.operation = operation;
    return this;
  }

  /**
   * The ID of the item that generated the notification.
   * The value returned may be {@code null}.
   */
  public String getItemId() {
    return itemId;
  }

  /**
   * The ID of the item that generated the notification.
   * The value set may be {@code null}.
   */
  public Notification setItemId(String itemId) {
    this.itemId = itemId;
    return this;
  }

}
