/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.glass.model;

import com.google.api.client.json.GenericJson;
import com.google.api.client.util.DateTime;

/**
 * Controls how notifications for a timeline item are presented to the user.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Glass Mirror API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class NotificationConfig extends GenericJson {

  /**
   * Controls how intrusive the notification will be. Allowed values are: - NO_NOTIFICATION - No
   * notification. This is the default value.  - AUDIO_ONLY - An audible notification.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String level;

  /**
   * The time at which the notification should be delivered.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private DateTime deliveryTime;

  /**
   * Controls how intrusive the notification will be. Allowed values are: - NO_NOTIFICATION - No
   * notification. This is the default value.  - AUDIO_ONLY - An audible notification.
   * The value returned may be {@code null}.
   */
  public String getLevel() {
    return level;
  }

  /**
   * Controls how intrusive the notification will be. Allowed values are: - NO_NOTIFICATION - No
   * notification. This is the default value.  - AUDIO_ONLY - An audible notification.
   * The value set may be {@code null}.
   */
  public NotificationConfig setLevel(String level) {
    this.level = level;
    return this;
  }

  /**
   * The time at which the notification should be delivered.
   * The value returned may be {@code null}.
   */
  public DateTime getDeliveryTime() {
    return deliveryTime;
  }

  /**
   * The time at which the notification should be delivered.
   * The value set may be {@code null}.
   */
  public NotificationConfig setDeliveryTime(DateTime deliveryTime) {
    this.deliveryTime = deliveryTime;
    return this;
  }

}
